package dev.shadowsoffire.apotheosis.util;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.Gem;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemRegistry;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.util.Collection;
import java.util.stream.Stream;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraftforge.common.crafting.AbstractIngredient;
import net.minecraftforge.common.crafting.IIngredientSerializer;

public class GemIngredient extends AbstractIngredient {
  protected final DynamicHolder<LootRarity> rarity;
  
  protected ItemStack[] items;
  
  public GemIngredient(DynamicHolder<LootRarity> rarity) {
    super(Stream.empty());
    this.rarity = rarity;
  }
  
  public boolean test(ItemStack stack) {
    DynamicHolder<LootRarity> rarity = AffixHelper.getRarity(stack);
    return (stack.m_41720_() == Adventure.Items.GEM.get() && rarity.isBound() && rarity == this.rarity);
  }
  
  public ItemStack[] m_43908_() {
    if (this.items == null) {
      Collection<Gem> gems = GemRegistry.INSTANCE.getValues();
      if (gems.size() == 0)
        return new ItemStack[0]; 
      this.items = new ItemStack[gems.size()];
      int i = 0;
      for (Gem g : GemRegistry.INSTANCE.getValues())
        this.items[i++] = GemRegistry.createGemStack(g, (LootRarity)this.rarity.get()); 
    } 
    return this.items;
  }
  
  protected void invalidate() {
    super.invalidate();
    this.items = null;
  }
  
  public boolean isSimple() {
    return false;
  }
  
  public IIngredientSerializer<? extends Ingredient> getSerializer() {
    return (IIngredientSerializer<? extends Ingredient>)Serializer.INSTANCE;
  }
  
  public JsonElement m_43942_() {
    return (JsonElement)new JsonObject();
  }
  
  public LootRarity getRarity() {
    return (LootRarity)this.rarity.get();
  }
}
